/****************************************************************
 * Configuration info.  This is very tacky. For now we are
 * doing this at compile time.  This is VERY SENSITIVE to the
 * placement of routines in the Fill[RPC|OTW|XPT] arrays.
 * This is a very poor substitute for dynamic loading of the
 * necessary routines so that things do not have to be re-linked
 * if/when we add a new protocol - but that issue is a rathole
 * we don't want to descend right now (6/25/86).  oystr
 ****************************************************************/

#ifndef UNSELECT
#define USE_COUR_RPC
#define USE_SUN_RPC
#endif

/*
 * Following are related to import binding.
 */
#ifdef USE_COUR_RPC
extern FillCourRPC();
extern FillCourOTW();
extern FillSPP_XPT();
#endif

#ifdef USE_SUN_RPC
extern FillSunRPC();
extern FillSunOTW();
extern FillSunTCP();
extern FillSunUDP();
#endif

extern abort();

int (* FillRPC[])() = {
    abort, 

#ifdef USE_SUN_RPC
    FillSunRPC,
#else
    abort,
#endif

#ifdef USE_COUR_RPC
    FillCourRPC
#else
    abort
#endif
};

int (* FillOTW[])() = {
    abort,

#ifdef USE_SUN_OTW
    FillSunOTW,
#else
    abort,
#endf

#ifdef USE_COUR_RPC
    FillCourOTW
#else
    abort
#endif
};

int (* FillXPT[])() = {
    abort,
#ifdef USE_SUN_RPC
    FillSunTCP, FillSunUDP,
#else
    abort, abort,
#endif

#ifdef USE_COUR_RPC
    FillSPP_XPT
#else
    abort
#endif
};

int (* ExportProcs[])() = {
    abort,

#ifdef USE_SUN_RPC
    ExportSunServer,
#else
    abort,
#endif

#ifdef USE_COUR_RPC
    ExportCourServer
#else
    abort
#endf
};
